#ifndef __SETSCROLLBAR_H__
#define __SETSCROLLBAR_H__

SCROLLINFO	si_h[2], si_v[2];				// XN[o[̏
int scr_x[2] = {0, 0}, scr_y[2] = {0, 0};	// ݂̃XN[o[̈ʒui`悷ۂɏo͂X,YWɂꂼA-scr_x, -scr_y j
int scr_x0[2] = {0, 0}, scr_y0[2] = {0, 0}; // ȑÕXN[o[̈ʒu

void Set_ScrollBar(HWND hWnd, int idx);						// WM_CREATE
void Set_Scroll_nMax(HWND hWnd, int wdh, int hgt, int idx);	// rbg}bvǂݍݎ	ۂ̕\TCY
void Set_Scroll_nPage(HWND hWnd, int idx);					// WM_SIZE					EBhẼTCY
void Del_Scroll(HWND hWnd, int idx);							// C
void Move_Scroll_H(HWND hWnd, WPARAM wParam, int idx);		// WM_HSCROLL
void Move_Scroll_V(HWND hWnd, WPARAM wParam, int idx);		// WM_VSCROLL


// XN[o[̏ݒ
void Set_ScrollBar(HWND hWnd, int idx)
{
	ZeroMemory(&si_v[idx],sizeof(si_v[idx]));
	si_v[idx].cbSize = sizeof(si_v[idx]);
	si_v[idx].fMask = SIF_RANGE | SIF_PAGE | SIF_POS;
	si_v[idx].nMin = 0;
	si_v[idx].nMax = 0;
	si_v[idx].nPage = 0;
	si_v[idx].nPos = 0;
	SetScrollInfo(hWnd,SB_VERT,&si_v[idx],TRUE);
	
	ZeroMemory(&si_h[idx],sizeof(si_h[idx]));
	si_h[idx].cbSize = sizeof(si_h[idx]);
	si_h[idx].fMask = SIF_RANGE | SIF_PAGE | SIF_POS;
	si_h[idx].nMin = 0;
	si_h[idx].nMax = 0;
	si_h[idx].nPage = 0;
	si_h[idx].nPos = 0;
	SetScrollInfo(hWnd,SB_HORZ,&si_h[idx],TRUE);
}// Set_ScrollBar

// 摜TCYXN[o[ɐݒ
void Set_Scroll_nMax(HWND hWnd ,int wdh, int hgt, int idx)
{
	si_h[idx].nMax = wdh - 1;		// XN[o[̍őlݒ
	scr_x[idx] = SetScrollInfo(hWnd,SB_HORZ,&si_h[idx],TRUE); // ݒKp
	si_v[idx].nMax = hgt - 1;		// cXN[o[̍őlݒ
	scr_y[idx] = SetScrollInfo(hWnd,SB_VERT,&si_v[idx],TRUE); // ݒKp
	ScrollWindowEx(hWnd,scr_x0[idx] - scr_x[idx],scr_y0[idx] - scr_y[idx],0,0,0,0,SW_INVALIDATE);
	scr_x0[idx] = scr_x[idx];
	scr_y0[idx] = scr_y[idx];
}// Set_Scroll_nMax

// NCAg̈̑傫XN[o[ɐݒ
void Set_Scroll_nPage(HWND hWnd, int idx)
{
	RECT rc;
	
	GetClientRect(hWnd,&rc);
	
	if(rc.right > 0 && rc.bottom > 0){
		si_h[idx].nPage = rc.right;
		if((unsigned)si_h[idx].nMax <= si_h[idx].nPage)	  si_h[idx].nPos = 0;
		scr_x[idx] = SetScrollInfo(hWnd,SB_HORZ,&si_h[idx],TRUE);
		si_v[idx].nPage = rc.bottom;
		if((unsigned)si_v[idx].nMax <= si_v[idx].nPage)	  si_v[idx].nPos = 0;
		scr_y[idx] = SetScrollInfo(hWnd,SB_VERT,&si_v[idx],TRUE);
		ScrollWindowEx(hWnd,scr_x0[idx] - scr_x[idx],scr_y0[idx] - scr_y[idx],0,0,0,0,SW_INVALIDATE);
		scr_x0[idx] = scr_x[idx];
		scr_y0[idx] = scr_y[idx];
	}
}// Set_Scroll_nPage

// XN[o[
void Del_Scroll(HWND hWnd, int idx)
{
	si_h[idx].nMax = 0;
	scr_x[idx] = SetScrollInfo(hWnd,SB_HORZ,&si_h[idx],TRUE);
	si_v[idx].nMax = 0;
	scr_y[idx] = SetScrollInfo(hWnd,SB_VERT,&si_v[idx],TRUE);
	ScrollWindowEx(hWnd,scr_x0[idx] - scr_x[idx],scr_y0[idx] - scr_y[idx],0,0,0,0,SW_INVALIDATE);
	scr_x0[idx] = scr_x[idx];
	scr_y0[idx] = scr_y[idx];
}// Del_Scroll

// XN[o[Ƃ
void Move_Scroll_H(HWND hWnd, WPARAM wParam, int idx)
{
	switch(LOWORD(wParam))
	{
	case SB_LEFT:
		si_h[idx].nPos = si_h[idx].nMin;
		break;
	case SB_RIGHT:
		si_h[idx].nPos = si_h[idx].nMax;
		break;
	case SB_LINELEFT:
		if (si_h[idx].nPos) si_h[idx].nPos--;
		break;
	case SB_LINERIGHT:
		if (si_h[idx].nPos < si_h[idx].nMax - 1) si_h[idx].nPos++;
		break;
	case SB_PAGELEFT:
		si_h[idx].nPos -= si_h[idx].nPage;
		break;
	case SB_PAGERIGHT:
		si_h[idx].nPos += si_h[idx].nPage;
		break;
	case SB_THUMBPOSITION:
		si_h[idx].nPos = HIWORD(wParam);
		break;
	case SB_THUMBTRACK:
		si_h[idx].nPos = HIWORD(wParam);
		break;
	case SB_ENDSCROLL:
		break;
	}
	
	scr_x[idx] = SetScrollInfo(hWnd,SB_HORZ,&si_h[idx],TRUE);
	if(scr_x[idx] != scr_x0[idx]){
		SendMessage(hWnd, WM_SETREDRAW, FALSE, 0);
		ScrollWindowEx(hWnd,scr_x0[idx] - scr_x[idx],0,0,0,0,0,NULL);
		SendMessage(hWnd, WM_SETREDRAW, TRUE, 0);
		InvalidateRect(hWnd, NULL, FALSE);
		scr_x0[idx] = scr_x[idx];
	}
}// Move_Scroll_H

// cXN[o[Ƃ
void Move_Scroll_V(HWND hWnd, WPARAM wParam, int idx)
{
	switch(LOWORD(wParam))
	{
	case SB_TOP:
		si_v[idx].nPos = si_v[idx].nMin;
		break;
	case SB_BOTTOM:
		si_v[idx].nPos = si_v[idx].nMax;
		break;
	case SB_LINEUP:
		if (si_v[idx].nPos) si_v[idx].nPos--;
		break;
	case SB_LINEDOWN:
		if (si_v[idx].nPos < si_v[idx].nMax - 1) si_v[idx].nPos++;
		break;
	case SB_PAGEUP:
		si_v[idx].nPos -= si_v[idx].nPage;
		break;
	case SB_PAGEDOWN:
		si_v[idx].nPos += si_v[idx].nPage;
		break;
	case SB_THUMBPOSITION:
		si_v[idx].nPos = HIWORD(wParam);
		break;
	case SB_THUMBTRACK:
		si_v[idx].nPos = HIWORD(wParam);
		break;
	case SB_ENDSCROLL:
		break;
	}
	
	scr_y[idx] = SetScrollInfo(hWnd,SB_VERT,&si_v[idx],TRUE);
	if(scr_y[idx] != scr_y0[idx]){
		SendMessage(hWnd, WM_SETREDRAW, FALSE, 0);
		ScrollWindowEx(hWnd,0,scr_y0[idx] - scr_y[idx],0,0,0,0,NULL);
		SendMessage(hWnd, WM_SETREDRAW, TRUE, 0);
		InvalidateRect(hWnd, NULL, FALSE);
		scr_y0[idx] = scr_y[idx];
	}
}// Move_Scroll_V

#endif // __SETSCROLLBAR_H__
