// ̈h
#ifndef __BUCKET_H__
#define __BUCKET_H__

#include <malloc.h>

void	Bucket(LPBYTE data, int x, int y, int wdh, int hgt, BYTE val_dst);
bool	Bucket_Sub  (LPBYTE data, int wdh, int hgt, BYTE val_src, BYTE val_dst);
POINT	Bucket_Sub_x(LPBYTE data, int wdh, int hgt, int xPos, int yPos, BYTE val_src, BYTE val_dst);
bool	Check_StackSize();

// ێX^bN
POINT	*g_pt_stack = NULL;
int		g_num_stack = 0;

// hԂ
// data    : hԂΏۂ̃f[^
// x,y     : NbNꂽsNZʒu
// val_dst : hԂl
void Bucket(LPBYTE data, int x, int y, int wdh, int hgt, BYTE val_dst)
{
	BYTE	val_src = data[y*wdh+x];
	
	if(val_src == val_dst){
		return;
	}
	
	FREE(g_pt_stack);
	g_pt_stack = (LPPOINT) malloc(1024*sizeof(POINT));
	
	g_num_stack = 0;
	g_pt_stack[g_num_stack].x = x;
	g_pt_stack[g_num_stack].y = y;
	
	Bucket_Sub(data, wdh, hgt, val_src, val_dst);
	
	FREE(g_pt_stack);
	g_num_stack = 0;
}// Bucket

// hԂ͈͂߂
bool Bucket_Sub(LPBYTE data, int wdh, int hgt, BYTE val_src, BYTE val_dst)
{
	bool	flag1,flag2,flag3;
	int 	x;
	int 	xPos,yPos;
	POINT	pt;
	BYTE	val;
	
	while(g_num_stack >= 0){	// X^bNɂȂI
		flag3 = 1;
		while (flag3){
			xPos = g_pt_stack[g_num_stack].x;
			yPos = g_pt_stack[g_num_stack].y;
			pt = Bucket_Sub_x(data, wdh, hgt, xPos, yPos, val_src, val_dst);
			flag1 = 0;
			flag2 = 0;
			flag3 = 0;
			for(x=pt.x; x<=pt.y; x++){
				// 
				if(yPos > 0){
					val = data[(yPos-1)*wdh+x];
					if(val_src != val){
						flag1 = 0;
					}
					else if(!flag1 && val_src == val){
						g_pt_stack[g_num_stack].x = x;
						g_pt_stack[g_num_stack].y = yPos-1;
						g_num_stack ++;
						if(!Check_StackSize())
							return 0;
						flag1 = 1;
						flag3 = 1;
					}
				}
				// 
				if(yPos < hgt - 1){
					val = data[(yPos+1)*wdh+x];
					if(val_src != val){
						flag2 = 0;
					}
					else if(!flag2 && val_src == val){
						g_pt_stack[g_num_stack].x = x;
						g_pt_stack[g_num_stack].y = yPos+1;
						g_num_stack ++;
						if(!Check_StackSize())
							return 0;
						flag2 = 1;
						flag3 = 1;
					}
				}
			}
			g_num_stack --;
			if(g_num_stack < 0) break;
		}
	}
	return 1;
}// Bucket_Sub

// _(xPos, yPos)̉̓lŘAsNZʒu߂
POINT Bucket_Sub_x(LPBYTE data, int wdh, int hgt, int xPos, int yPos, BYTE val_src, BYTE val_dst)
{
	int		x;
	POINT	pt;
	BYTE	val;
	
	// _(xPos, yPos)̍𒲂ׂ
	x = 0;
	while (xPos >= x){
		val = data[yPos*wdh+(xPos-x)];
		if(val_src == val)
			data[yPos*wdh+(xPos-x)] = val_dst;
		else
			break;
		x ++;
	}
	pt.x = xPos - (x - 1);
	
	// _(xPos, yPos)̉E𒲂ׂ
	x = 1;
	while (x < (wdh - xPos)){
		val = data[yPos*wdh+(xPos+x)];
		if(val_src == val)
			data[yPos*wdh+(xPos+x)] = val_dst;
		else
			break;
		x ++;
	}
	pt.y = xPos + (x - 1);
	
	return pt;
}// Bucket_Sub_x

// X^bNg؂AX^bNTCY𑝂₷
bool Check_StackSize()
{
	size_t size = _msize(g_pt_stack);
	if(g_num_stack * sizeof(POINT) >= size){
		g_pt_stack = (POINT*)realloc(g_pt_stack, size+512*sizeof(POINT));
		if(!g_pt_stack){
			return 0;
		}
	}
	return 1;
}// Check_StackSize

#endif // __BUCKET_H__
